"""auto

Revision ID: a36b3dd5e852
Revises:
Create Date: 2023-05-28 00:18:17.313011

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = "a36b3dd5e852"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "pages",
        sa.Column("created_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("updated_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("url", sa.Text(), nullable=False),
        sa.Column("checksum", sa.String(length=255), nullable=True),
        sa.PrimaryKeyConstraint("id"),
        sa.UniqueConstraint("checksum"),
    )
    op.create_index(op.f("ix_pages_id"), "pages", ["id"], unique=False)
    op.create_index(op.f("ix_pages_url"), "pages", ["url"], unique=True)
    op.create_table(
        "page_tasks",
        sa.Column("created_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("updated_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("status", sa.Enum("processing", "failed", "finished", name="statusenum"), nullable=True),
        sa.Column("page_id", sa.Integer(), nullable=True),
        sa.ForeignKeyConstraint(["page_id"], ["pages.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(op.f("ix_page_tasks_id"), "page_tasks", ["id"], unique=False)
    op.create_index(op.f("ix_page_tasks_page_id"), "page_tasks", ["page_id"], unique=False)
    op.create_index(op.f("ix_page_tasks_status"), "page_tasks", ["status"], unique=False)
    op.create_table(
        "paragraphs",
        sa.Column("created_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("updated_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("text", sa.Text(), nullable=True),
        sa.Column("order", sa.Integer(), nullable=True),
        sa.Column("page_id", sa.Integer(), nullable=True),
        sa.ForeignKeyConstraint(["page_id"], ["pages.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(op.f("ix_paragraphs_id"), "paragraphs", ["id"], unique=False)
    op.create_index(op.f("ix_paragraphs_page_id"), "paragraphs", ["page_id"], unique=False)
    op.create_index(op.f("ix_paragraphs_text"), "paragraphs", ["text"], unique=True)
    op.create_table(
        "paragraph_facts",
        sa.Column("created_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("updated_at", sa.DateTime(), server_default=sa.text("now()"), nullable=True),
        sa.Column("id", sa.Integer(), autoincrement=True, nullable=False),
        sa.Column("text", sa.Text(), nullable=True),
        sa.Column("embedding", sa.ARRAY(sa.Float()), nullable=True),
        sa.Column("paragraph_id", sa.Integer(), nullable=True),
        sa.ForeignKeyConstraint(["paragraph_id"], ["paragraphs.id"], ondelete="CASCADE"),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_index(op.f("ix_paragraph_facts_id"), "paragraph_facts", ["id"], unique=False)
    op.create_index(op.f("ix_paragraph_facts_paragraph_id"), "paragraph_facts", ["paragraph_id"], unique=False)
    op.create_index(op.f("ix_paragraph_facts_text"), "paragraph_facts", ["text"], unique=True)
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_paragraph_facts_text"), table_name="paragraph_facts")
    op.drop_index(op.f("ix_paragraph_facts_paragraph_id"), table_name="paragraph_facts")
    op.drop_index(op.f("ix_paragraph_facts_id"), table_name="paragraph_facts")
    op.drop_table("paragraph_facts")
    op.drop_index(op.f("ix_paragraphs_text"), table_name="paragraphs")
    op.drop_index(op.f("ix_paragraphs_page_id"), table_name="paragraphs")
    op.drop_index(op.f("ix_paragraphs_id"), table_name="paragraphs")
    op.drop_table("paragraphs")
    op.drop_index(op.f("ix_page_tasks_status"), table_name="page_tasks")
    op.drop_index(op.f("ix_page_tasks_page_id"), table_name="page_tasks")
    op.drop_index(op.f("ix_page_tasks_id"), table_name="page_tasks")
    op.drop_table("page_tasks")
    op.drop_index(op.f("ix_pages_url"), table_name="pages")
    op.drop_index(op.f("ix_pages_id"), table_name="pages")
    op.drop_table("pages")
    # ### end Alembic commands ###
